﻿// WriteLine.cpp : このファイルには 'main' 関数が含まれています。プログラム実行の開始と終了がそこで行われます。
//

#include <iostream>
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <strsafe.h>

#include "logout.h"

char logmsg[256];

//関数プロトタイプ宣言
extern void DisplayError(LPTSTR lpszFunction);

int __cdecl _tmain(int argc, TCHAR* argv[])
{
//    MoveFile((const char*)"./wktrace.log", (const char*)"./wktrace_123.log");

    loginit((char*)"apptrace.log");

    strcpy_s(logmsg, "_tmain() start");
    logout(TEXT_LOG,3, logmsg, (int)strlen(logmsg));

    HANDLE hFile;
    BOOL bErrorFlag = FALSE;
    char DataBuffer[] = "This is some test data to write to the file.\r\n";
    char crlf[] = { "\r\n" };
    char CRLF[] = { 0x0d, 0x0a };
    DWORD dwBytesToWrite = (DWORD)strlen(DataBuffer);
    DWORD dwBytesWritten = 0;

    char fpath[]="sample.txt";

    hFile = CreateFile(fpath,                // name of the write
        GENERIC_WRITE,          // open for writing
        0,                      // do not share
        NULL,                   // default security
        CREATE_ALWAYS,             // create new file only
        FILE_ATTRIBUTE_NORMAL,  // normal file
        NULL);                  // no attr. template

    if (hFile == INVALID_HANDLE_VALUE)
    {
        DisplayError((LPTSTR)"CreateFile");
        _tprintf(TEXT("Terminal failure: Unable to open file \"%s\" for write.\n"), argv[1]);
        return 1;
    }
    char DataBuffer2[256] = " Hello World!!";

    strcat_s(DataBuffer2, sizeof(DataBuffer2),crlf);
    dwBytesToWrite= (DWORD)(strlen(DataBuffer2));

    bErrorFlag = WriteFile(
        hFile,           // open file handle
        DataBuffer2,      // start of data to write
        dwBytesToWrite,  // number of bytes to write
        &dwBytesWritten, // number of bytes that were written
        NULL);            // no overlapped structure

    strcpy_s(logmsg, "_tmain() 002");
    logout(TEXT_LOG, 3, logmsg, (int)strlen(logmsg));


    char dummyValue[] = {1, 2, 3 , 4 ,5 ,6 ,7 ,8 , 9, 10, 11, 12, 13, 14, 15, 16,17};
    logout(BIN_LOG, 3, (char*) & dummyValue, sizeof(dummyValue)/sizeof(dummyValue[0]));

    //改行出力
    //dwBytesToWrite = sizeof(CRLF);
    //bErrorFlag = WriteFile(
    //    hFile,           // open file handle
    //    CRLF,      // start of data to write
    //    dwBytesToWrite,  // number of bytes to write
    //    &dwBytesWritten, // number of bytes that were written
    //    NULL);            // no overlapped structure

    if (FALSE == bErrorFlag)
    {
        DisplayError((LPTSTR)"WriteFile");
        printf("Terminal failure: Unable to write to file.\n");
    }
    
    CloseHandle(hFile);

    strcpy_s(logmsg, "_tmain() 003");
    logout(TEXT_LOG, 3, logmsg, (int)strlen(logmsg));

    strcpy_s(logmsg, "_tmain() end");
    logout(TEXT_LOG, 3, logmsg, (int)strlen(logmsg));

    return 0;
}
#if 0
void DisplayError(LPTSTR lpszFunction)
// Routine Description:
// Retrieve and output the system error message for the last-error code
{
    LPVOID lpMsgBuf;
    LPVOID lpDisplayBuf;
    DWORD dw = GetLastError();

    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER |
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        dw,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR)&lpMsgBuf,
        0,
        NULL);

    lpDisplayBuf =
        (LPVOID)LocalAlloc(LMEM_ZEROINIT,
            (lstrlen((LPCTSTR)lpMsgBuf)
                + lstrlen((LPCTSTR)lpszFunction)
                + 40) // account for format string
            * sizeof(TCHAR));

    if (FAILED(StringCchPrintf((LPTSTR)lpDisplayBuf,
        LocalSize(lpDisplayBuf) / sizeof(TCHAR),
        TEXT("%s failed with error code %d as follows:\n%s"),
        lpszFunction,
        dw,
        lpMsgBuf)))
    {
        printf("FATAL ERROR: Unable to output error code.\n");
    }

    _tprintf(TEXT("ERROR: %s\n"), (LPCTSTR)lpDisplayBuf);

    LocalFree(lpMsgBuf);
    LocalFree(lpDisplayBuf);
}
#endif
// プログラムの実行: Ctrl + F5 または [デバッグ] > [デバッグなしで開始] メニュー
// プログラムのデバッグ: F5 または [デバッグ] > [デバッグの開始] メニュー

// 作業を開始するためのヒント: 
//    1. ソリューション エクスプローラー ウィンドウを使用してファイルを追加/管理します 
//   2. チーム エクスプローラー ウィンドウを使用してソース管理に接続します
//   3. 出力ウィンドウを使用して、ビルド出力とその他のメッセージを表示します
//   4. エラー一覧ウィンドウを使用してエラーを表示します
//   5. [プロジェクト] > [新しい項目の追加] と移動して新しいコード ファイルを作成するか、[プロジェクト] > [既存の項目の追加] と移動して既存のコード ファイルをプロジェクトに追加します
//   6. 後ほどこのプロジェクトを再び開く場合、[ファイル] > [開く] > [プロジェクト] と移動して .sln ファイルを選択します
